/* ==============================================================================================================
 *
 *                             VOIR_DEMAIN_CODES - Codes météo fournis par le site Météo Concept
 *                    Cf. bas de la page https://api.meteo-concept.com/documentation#forecast-city-day
 *
 *   - La table GL_allWeathertCodes donne l'ensemble des codes possibles fournis par le serveur météo.
 *   - La fonction getWeatherAbstract, plus bas, fournit un résumé entre 0 et 4, correspondant aux 5 états 
 *     affichables par notre maquette : 
 *                   [0] Soleil,[1] Nuages+Soleil, [2] Nuages, [3] Pluie, [4] Orages. 
 * =============================================================================================================*/

char* GL_allWeatherCodes[] = {
  /*0*/       "Soleil",
  /*1*/       "Peu nuageux",
  /*2*/       "Ciel voilé",
  /*3*/       "Nuageux",
  /*4*/       "Très nuageux",
  /*5*/       "Couvert",
  /*6*/       "Brouillard",
  /*7*/       "Brouillard givrant",
  /*8-9*/     "8", "9",
  /*10*/      "Pluie faible",
  /*11*/      "Pluie modérée",
  /*12*/      "Pluie forte",
  /*13*/      "Pluie faible verglaçante",
  /*14*/      "Pluie modérée verglaçante",
  /*15*/      "Pluie forte verglaçante",
  /*16*/      "Bruine",
  /*17-19*/   "17", "18", "19",
  /*20*/      "Neige faible",
  /*21*/      "Neige modérée",
  /*22*/      "Neige forte",
  /*23-29*/   "23", "24", "25", "26", "27", "28", "29",
  /*30*/      "Pluie et neige mêlées faibles",
  /*31*/      "Pluie et neige mêlées modérées",
  /*32*/      "Pluie et neige mêlées fortes",
  /*33-39*/   "33", "34", "35", "36", "37", "38", "39",
  /*40*/      "Averses de pluie locales et faibles",
  /*41*/      "Averses de pluie locales",
  /*42*/      "Averses locales et fortes",
  /*43*/      "Averses de pluie faibles",
  /*44*/      "Averses de pluie",
  /*45*/      "Averses de pluie fortes",
  /*46*/      "Averses de pluie faibles et fréquentes",
  /*47*/      "Averses de pluie fréquentes",
  /*48*/      "Averses de pluie fortes et fréquentes",
  /*49-59*/   "49",
  "50", "51", "52", "53", "54", "55", "56", "57", "58", "59",
  /*60*/      "Averses de neige localisées et faibles",
  /*61*/      "Averses de neige localisées",
  /*62*/      "Averses de neige localisées et fortes",
  /*63*/      "Averses de neige faibles",
  /*64*/      "Averses de neige",
  /*65*/      "Averses de neige fortes",
  /*66*/      "Averses de neige faibles et fréquentes",
  /*67*/      "Averses de neige fréquentes",
  /*68*/      "Averses de neige fortes et fréquentes",
  /*69*/      "69",
  /*70*/      "Averses de pluie et neige mêlées localisées et faibles",
  /*71*/      "Averses de pluie et neige mêlées localisées",
  /*72*/      "Averses de pluie et neige mêlées localisées et fortes",
  /*73*/      "Averses de pluie et neige mêlées faibles",
  /*74*/      "Averses de pluie et neige mêlées",
  /*75*/      "Averses de pluie et neige mêlées fortes",
  /*76*/      "Averses de pluie et neige mêlées faibles et nombreuses",
  /*77*/      "Averses de pluie et neige mêlées fréquentes",
  /*78*/      "Averses de pluie et neige mêlées fortes et fréquentes",
  /*79-99*/   "79",
  "80", "81", "82", "83", "84", "85", "86", "87", "88", "89",
  "90", "91", "92", "93", "94", "95", "96", "97", "98", "99",
  /*100*/     "Orages faibles et locaux",
  /*101*/     "Orages locaux",
  /*102*/     "Orages fort et locaux",
  /*103*/     "Orages faibles",
  /*104*/     "Orages",
  /*105*/     "Orages forts",
  /*106*/     "Orages faibles et fréquents",
  /*107*/     "Orages fréquents",
  /*108*/     "Orages forts et fréquents",
  /*109-119*/ "109",
  "110", "111", "112", "113", "114", "115", "117", "117", "118", "119",
  /*120*/     "Orages faibles et locaux de neige ou grésil",
  /*121*/     "Orages locaux de neige ou grésil",
  /*122*/     "Orages locaux de neige ou grésil",
  /*123*/     "Orages faibles de neige ou grésil",
  /*124*/     "Orages de neige ou grésil",
  /*125*/     "Orages de neige ou grésil",
  /*126*/     "Orages faibles et fréquents de neige ou grésil",
  /*127*/     "Orages fréquents de neige ou grésil",
  /*128*/     "Orages fréquents de neige ou grésil",
  /*129*/     "129",
  /*130*/     "Orages faibles et locaux de pluie et neige mêlées ou grésil",
  /*131*/     "Orages locaux de pluie et neige mêlées ou grésil",
  /*132*/     "Orages fort et locaux de pluie et neige mêlées ou grésil",
  /*133*/     "Orages faibles de pluie et neige mêlées ou grésil",
  /*134*/     "Orages de pluie et neige mêlées ou grésil",
  /*135*/     "Orages forts de pluie et neige mêlées ou grésil",
  /*136*/     "Orages faibles et fréquents de pluie et neige mêlées ou grésil",
  /*137*/     "Orages fréquents de pluie et neige mêlées ou grésil",
  /*138*/     "Orages forts et fréquents de pluie et neige mêlées ou grésil",
  /*139*/     "139",
  /*140*/     "Pluies orageuses",
  /*141*/     "Pluie et neige mêlées à caractère orageux",
  /*142*/     "Neige à caractère orageux",
  /*143-209*/ "143", "144", "145", "146", "147", "148", "149",
  "150", "151", "152", "153", "154", "155", "156", "157", "158", "159",
  "160", "161", "162", "163", "164", "165", "166", "167", "168", "169",
  "170", "171", "172", "173", "174", "175", "176", "177", "178", "179",
  "180", "181", "182", "183", "184", "185", "186", "187", "188", "189",
  "190", "191", "192", "193", "194", "195", "196", "197", "198", "199",
  "200", "201", "202", "203", "204", "205", "206", "207", "208", "209",
  /*210*/     "Pluie faible intermittente",
  /*211*/     "Pluie modérée intermittente",
  /*212*/     "Pluie forte intermittente",
  /*213-219*/ "213", "214", "215", "216", "217", "218", "219",
  /*220*/     "Neige faible intermittente",
  /*221*/     "Neige modérée intermittente",
  /*222*/     "Neige forte intermittente",
  /*223-229*/ "223", "224", "225", "226", "227", "228", "229",
  /*230*/     "Pluie et neige mêlées",
  /*231*/     "Pluie et neige mêlées",
  /*232*/     "Pluie et neige mêlées",
  /*233-234*/ "233", "234",
  /*235*/     "Averses de grêle"
} ;

/* -------------------------------------------------------------------------------------------------------------
 * getWeatherAbstract() : obtention du code météo [0 à 4] à partir du code "weather" de Météo Concept.
 * ------------------------------------------------------------------------------------------------------------- */
int getWeatherAbstract(int wCode) {

  if (wCode <= 1) { return (0) ; }
  if (wCode <= 3) { return (1) ; }
  if (wCode < 78) { return (2) ; }
  if (wCode < 142) { return (3) ; }
  return (3) ;

}

/* -------------------------------------------------------------------------------------------------------------
 * testWeatherCodes() : juste pour valider la table GL_allWeatherCodes
 * ------------------------------------------------------------------------------------------------------------- */
void testWeatherCodes() {

    for (int i = 0; i <= 235; i++) {
        Serial.println("[" + String(i) + "] " + String(GL_allWeatherCodes[i])) ;
    }

}

/* -------------------------------------------------------------------------------------------------------------
   Requête pour notre POCL "Voir Demain" (météo des 14 prochains jours sur Rennes, code insee = 35238) :

   https://api.meteo-concept.com/api/forecast/daily?token=54202d9b9f01cd1ee6d200372c7aec3661ac09f0ed9f526e85359de6eb064988&insee=35238

   Attention le n° de token est lié à une inscription personnelle de l'auteur de ces lignes, sur le site Metéo Concept.
   Nous avons droit à 500 requêtes par jour pour l'offre gratuite. Il vous faudra peut-être une nouvelle inscription,
   voire un passage à une offre payante si cette maquette est reproduite à trop grande échelle.
   -------------------------------------------------------------------------------------------------------------
   Extrait de la réponse obtenue :

   {
       "city": {
           "insee": "35238",                              <-- ça, c'est Rennes
           (...)
      },
      "update": "2020-10-29T12:40:08+0100",               <-- Date de la réponse
      "forecast": [
           {
               "insee": "35238",
               (...)
               "datetime": "2020-10-29T01:00:00+0100",    <-- Date de la prévision
               (...)
               "weather": 4,                              <-- Code qui sera utilisé par notre programme
               (...)                                          (voir valeurs possibles en bas de page)
           },
           {
               (... idem pour "datetime": "2020-10-30T01:00:00+0100")
     },
           {
               (... idem pour "datetime": "2020-10-31T01:00:00+0100")
     },

           (... ainsi de suite jusqu'à "datetime": "2020-11-11T01:00:00+0100")
       ]
   }
